unit EditWebList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  Tfrm_WebList = class(TForm)
    Memo1: TMemo;
    btnLoad: TButton;
    btnSaveAs: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    btnClose: TButton;
    Label1: TLabel;
    lblName: TLabel;
    btnSave: TButton;
    procedure btnLoadClick(Sender: TObject);
    procedure btnSaveAsClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private 錾 }
    LoadPath:String;
    SavePath:String;
  public
    { Public 錾 }
  end;

var
  frm_WebList: Tfrm_WebList;

implementation

uses MAIN;

{$R *.DFM}

procedure Tfrm_WebList.btnLoadClick(Sender: TObject);
begin
  //JgfBNgw
	OpenDialog1.InitialDir:=LoadPath;
	if OpenDialog1.Execute then
  begin
	  Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
	  SavePath:=OpenDialog1.FileName;
	  lblName.Caption:=ExtractFileName(SavePath);
  end;
end;

procedure Tfrm_WebList.btnSaveAsClick(Sender: TObject);
begin
  //JgfBNgw
	SaveDialog1.InitialDir:=LoadPath;
	if SaveDialog1.Execute then
  begin
 		Memo1.Lines.SaveToFile(SaveDialog1.FileName);
	  SavePath:=SaveDialog1.FileName;
  	lblName.Caption:=ExtractFileName(SavePath);
  end;  
end;

procedure Tfrm_WebList.btnCloseClick(Sender: TObject);
begin
	//MainForm̃j[XV
	  MainForm.EnumFiles(LoadPath);
	//
		Close;
end;

procedure Tfrm_WebList.FormCreate(Sender: TObject);
begin
    lblName.Caption:='';
	//LoadPath̏
  	LoadPath:=MainForm.MyPath+'WebList';

end;

procedure Tfrm_WebList.btnSaveClick(Sender: TObject);
begin
//㏑ۑ
	if OpenDialog1.FileName<>'' then
  begin
  	Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
  end else begin
  	btnSaveAs.OnClick(btnSaveAs);
  end;    
end;

end.
