unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrlsR, StdActns,
  ActnList, ToolWin, ImgList, MSXML_TLB,ComObj,IniFiles,SHDocVw, ComCtrls,
  Masks,Clipbrd;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    mnuFile_SaveAs: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar1: TToolBar;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    ImageList1: TImageList;
    Tool1: TMenuItem;
    EngineItem: TMenuItem;
    IE_item: TMenuItem;
    Moz_Item: TMenuItem;
    mnuBookMark: TMenuItem;
    mnuBMEdit: TMenuItem;
    N4: TMenuItem;
    mnuOption: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton6: TToolButton;
    BackCtrl: TToolButton;
    FrwrdCtrl: TToolButton;
    StopCtrl: TToolButton;
    ReLoadCtrl: TToolButton;
    ToolBar3: TToolBar;
    Label1: TLabel;
    txtAddress: TEdit;
    btnMove: TButton;
    JBar: TToolBar;
    TreeView1: TTreeView;
    btnBar: TButton;
    mnuShow: TMenuItem;
    mnuShow_Bar: TMenuItem;
    mnuShow_default: TMenuItem;
    mnuShow_Address: TMenuItem;
    mnuShow_Status: TMenuItem;
    mnuShow_J: TMenuItem;
    N2: TMenuItem;
    mnuShow_Size: TMenuItem;
    mnuEdit: TMenuItem;
    mnuEdit_slrAll: TMenuItem;
    mnuSize_Max: TMenuItem;
    mnuSize_Large: TMenuItem;
    mnuSize_middle: TMenuItem;
    mnuSize_Small: TMenuItem;
    mnuSize_Min: TMenuItem;
    N5: TMenuItem;
    mnuEdit_Copy: TMenuItem;
    TabBar: TToolBar;
    TabPopup: TPopupMenu;
    popTabClose: TMenuItem;
    mnuShow_Tab: TMenuItem;
    N3: TMenuItem;
    N6: TMenuItem;
    popAddClose: TMenuItem;
    popAddBookMark: TMenuItem;
    TabControl1: TTabControl;
    mnuWebList: TMenuItem;
    mnuWebList_Edit: TMenuItem;
    N7: TMenuItem;
    mnuNew_blank: TMenuItem;
    mnuNew_Cilp: TMenuItem;
    N8: TMenuItem;
    mnu_AllClose: TMenuItem;
    mnu_AllCloseNotMe: TMenuItem;
    N9: TMenuItem;
    mnuLeastURL: TMenuItem;
    mnuLeastURL_Child: TMenuItem;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure txtAddressKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ToolButton1Click(Sender: TObject);
    procedure Moz_ItemClick(Sender: TObject);
    procedure IE_ItemClick(Sender: TObject);
    procedure iventMenuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuBMEditClick(Sender: TObject);
    procedure BackCtrlClick(Sender: TObject);
    procedure FrwrdCtrlClick(Sender: TObject);
    procedure StopCtrlClick(Sender: TObject);
    procedure ReLoadCtrlClick(Sender: TObject);
    procedure mnuOptionClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnMoveClick(Sender: TObject);
    procedure CoolBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BandPositionRead();
    procedure BandPositionWrite();
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure JBarResize(Sender: TObject);
    procedure btnBarClick(Sender: TObject);
    procedure JBarMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuShow_defaultClick(Sender: TObject);
    procedure mnuShow_AddressClick(Sender: TObject);
    procedure mnuShow_StatusClick(Sender: TObject);
    procedure mnuShow_JClick(Sender: TObject);
    procedure ViewToolBar();
    procedure mnuFile_SaveAsClick(Sender: TObject);
    procedure mnuSize_MaxClick(Sender: TObject);
    procedure mnuSize_LargeClick(Sender: TObject);
    procedure mnuSize_middleClick(Sender: TObject);
    procedure mnuSize_SmallClick(Sender: TObject);
    procedure mnuSize_MinClick(Sender: TObject);
    procedure mnuEdit_slrAllClick(Sender: TObject);
    procedure ReadMojiSize();
    procedure mnuEdit_CopyClick(Sender: TObject);
    procedure popTabCloseClick(Sender: TObject);
    procedure mnuShow_TabClick(Sender: TObject);
    procedure popAddCloseClick(Sender: TObject);
    procedure popAddBookMarkClick(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure TabControl1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TabControl1DrawTab(Control: TCustomTabControl;
      TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure HandleAppMessage(var Msg: TMsg; var Handled: Boolean);
		procedure EnumFiles(DirectoryName: string);
    procedure mnuWebList_EditClick(Sender: TObject);
    procedure mnuNew_CilpClick(Sender: TObject);
    procedure mnu_AllCloseClick(Sender: TObject);
    procedure mnu_AllCloseNotMeClick(Sender: TObject);
    procedure mnuLeastURLClick(Sender: TObject);

  private
    { Private 錾 }
    StartBool:Bool;
    comBool:Bool;
    procedure HomePages();
    procedure CommandLine();
    procedure OnClickWebList_Item(Sender: TObject);
    procedure OnClickLeast_Item(Sender: TObject);
	public
    { Public 錾 }
   //tab֌W
    intTabIndex:Byte;
    intMDICount:Integer;
    strsTab : TStrings;
    TabBool:ByteBool;
    CloseTabs:TStrings;
   //̑
    MyPath: String;
    WindowSize:TWindowState;
    intMojiSize:OLEVariant;
    procedure ReadBookMark();
        procedure JBarCreate();
    procedure CreateMDIChild(const Name: string;
                             const URL : string);
    //j[ǉ
    function AddMenu(OwnerMenu : TMenuItem ; Title : AnsiString ; Index : Integer) : TMenuItem;
    //TufBNg̍쐬
    function  mnuDir(tmpXMLNode:IXMLDOMNode ; xmlMenu:TMenuItem):IXMLDOMNode;
    //PopL}~
		function CloseURL(tmpURL:string):Bool;
end;

const
	BandCount=2;//CoolBar̃oh

var
  MainForm: TMainForm;

implementation

uses
 ChildIE, ChildMoz, About, Bookmark,
		 Option, untTab, untBMB, EditWebList;


{$R *.DFM}

procedure TMainForm.CommandLine();
var
	i:Byte;
begin
   ComBool:=False;
   if  ParamCount  > 0 then
   begin
   		ComBool:=True;
			{ 󂯎p[^J܂ }
			for i :=  1 to  ParamCount  do
    	begin
				CreateMDIChild('londing',ParamStr(i));
			end; {for}
   	end;
end;


//-------------------֐-----------------

//L}~ŃChJ[hgp
function Match(const Name{ChJ[h}, Mask:string):Boolean;
var
  Msk: TMask;
begin
  Msk := TMask.Create(Mask);
  try
    Result := Msk.Matches(Name);
  finally
    Msk.Free;
  end;
end;

//L}~@\(CloseURL)
function TMainForm.CloseURL(tmpURL:string):Bool;
var
	Winini: TIniFile;
	chkBool,tmpBool: Bool;
  tmpStrs:TStrings;
  i:Byte;
begin
  tmpStrs:=TStringList.Create;

	WinIni := TIniFile.Create(MyPath+'config.ini');
  chkBool:=Winini.ReadBool('Option_advertisemen','CloseURL',False);
  tmpBool:=False;

  if chkBool=True then
  begin
		tmpStrs.LoadFromFile(myPath+'CloseURL.txt');

    for i:= 0 to tmpStrs.Count-1 do
    begin
      if Match(tmpURL,tmpStrs.Strings[i]) then
      tmpBool:=True;
    end;
  end;

  result:=tmpBool;
end;

function TMainForm.AddMenu(OwnerMenu : TMenuItem ; Title : AnsiString ; Index : Integer) : TMenuItem;
//ʃj[Captionp̕AƏʃj[ACëʒuɂƂ܂B
var
   NewItem : TMenuItem;
begin
   NewItem := TMenuItem.Create(self);
   NewItem.Caption := Title;
   NewItem.Visible := true;
   NewItem.Enabled := true;
   OwnerMenu.Insert(Index ,NewItem);

   result := NewItem;
end;

//TufBNg쐬
function  TMainForm.mnuDir(tmpXMLNode:IXMLDOMNode ; xmlMenu:TMenuItem):IXMLDOMNode;
var
  tmpMenu: TMenuItem;//̃j[
  tmpNode:IXMLDOMNode;
  i:byte;
begin
  //`hJԂ
  for i := 1 to tmpXMLNode.parentNode.childNodes.length-1 do
  begin
    if tmpXMLNode.parentNode.Get_nodeName='directory' then begin
      //TufBNg
      tmpNode:=tmpXMLNode.parentNode.childNodes.item[i].firstChild;
      tmpMenu:=MainForm.AddMenu(xmlMenu,'&'+tmpNode.text , i-1);
      //ACR
			tmpMenu.ImageIndex:=11;
        //fileAURL
          if tmpNode.parentNode.baseName<>'directory' then begin
            tmpMenu.Hint:=tmpNode.parentNode.lastChild.text;
            //ACR
            tmpMenu.ImageIndex:=12;
          end;
        //OnClickCxgo^
          tmpMenu.OnClick:=MainForm.iventMenuClick;

      //fBNg΂xJ
      if tmpNode.parentNode.baseName='directory' then mnuDir(tmpNode,tmpMenu);
    end;
  end;

end;

//-------------------葱---------------


procedure TMainForm.HomePages();
var
	Winini: TIniFile;
  Path:String;
  select,i:Byte;
	WebLists:TStrings;
begin
//z[y[W̐ݒ
  //WebList̏
	WebLists:=TStringList.Create;
  //iniFile̓ǂݍ
	WinIni := TIniFile.Create(MyPath+'config.ini');
  Path:=WinIni.ReadString('Option_StartUp','Path','');
  select:=WinIni.ReadInteger('Option_StartUp','Type',0);
  WinIni.Free;

	case select of
	1:begin//wURLŊJ
			CreateMDIChild('Loading',Path);
		end;
	2:begin//wWebListŊJ
			if FileExists(Path) then //patht@C݂邩ǂ`FbN
    	begin
				WebLists.LoadFromFile(Path);
  			//ǂݍ񂾃ACeɊJ
  			for i:= 0 to WebLists.Count-1 do
	  		begin
					CreateMDIChild('londing',WebLists.Strings[i]);
  			end;
      end;
	  end;
	end;
  
end;

procedure TMainForm.EnumFiles(DirectoryName: string);
var
  SearchRec: TSearchRec;
  f,i:Byte;
  tmpMenu:TMenuItem;
begin
	f:=0;
  // Ԍ '\' ĂȂΕt
    DirectoryName:= IncludeTrailingBackslash(DirectoryName);

  //WebList̏
	if mnuWebList.Count>2 then begin
  	for i:=3 to mnuWebList.Count do
    begin
    	mnuWebList.Delete(2);
    end;
  end;

  // FindFirst ꍇ̂ FindClose ĂԕKv
  if 0=FindFirst(DirectoryName+'*.*', faAnyFile, SearchRec) then try
    repeat
      if SearchRec.Attr and faDirectory <> 0 then begin
        // JgfBNgefBNgXLbv
        if (SearchRec.Name='.') and (SearchRec.Name='..') then
          Continue;
        // fBNgɑ΂鏈
        // SearchRec.Name ɃfBNgĂ
        // Ƃ΁AMemo1.Lines.Add('Dir :'+DirectoryName+SearchRec.Name);
      end else begin
        // t@Cɑ΂鏈
        // SearchRec.Name Ƀt@CĂ
        //j[ǉ
        tmpMenu:=AddMenu(mnuWebList,'&'+Copy(SearchRec.Name,0,
        												Length(SearchRec.Name)-4),f+2);
        tmpMenu.Hint:=SearchRec.Name;
        tmpMenu.ImageIndex:=13;
        //OnClickCxgo^
          tmpMenu.OnClick:=MainForm.OnClickWebList_item;

        f:=f+1;
      end;
    until 0<>FindNext(SearchRec);
  finally
    FindClose(SearchRec);
  end;
end;

//BookMark̓ǂݍ
procedure TMainForm.ReadBookMark() ;
var
  tmpMenu: tmenuItem;//̃j[
  xmlDoc  :IXMLDOMDOCUMENT;
  DomName :IXMLDOMNode;
  i:byte;
begin

  //ubN}[N̏
	if mnuBookMark.Count>2 then begin
  	for i:=3 to mnuBookMark.Count do
    begin
    	mnuBookMark.Delete(2);
    end;
  end;

  //XMLIuWFNg̍쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                          IXMLDOMDOCUMENT;
  xmlDoc.load('bookmark.xml');
  xmlDoc.documentElement  ;
  //m[ho^
  for i := 0 to xmlDoc.documentElement.childNodes.length-1 do
  begin
  DomName:=
    xmlDoc.documentElement.childNodes.item[i].firstChild;
  //m[h̃eLXgj[ɒǉ
   tmpMenu:=AddMenu(mnuBookMark,'&'+DomName.Get_text, i+2);
   tmpMenu.ImageIndex:=11;
   //fileAURL
    if DomName.parentNode.baseName<>'directory' then
    begin
      tmpMenu.Hint:=DomName.parentNode.lastChild.text;
      tmpMenu.ImageIndex:=12;
    end;

   //OnClickCxgo^
    tmpMenu.OnClick:=iventMenuClick;

   mnuDir(DomName,tmpMenu);
	end;

end;

//JBar̈ʒu̓ǂݍ
procedure TMainForm.BandPositionRead();
var
	ini: TIniFile;
	BandIDNumber,BandWidth: array[0..BandCount-1] of Integer;
	BandBreak: array[0..BandCount-1] of Boolean;
	i: Integer;
begin
	Ini := TIniFile.Create(MyPath+'config.ini');
	with ini do
	try
		for i:=0 to BandCount-1 do
		begin//Band̈ʒuBreakǍ
			BandIDNumber[i]:=
      	ReadInteger('Bar','Band'+IntToStr(i)+'ID',i);
			BandWidth[i]   :=
				ReadInteger('Bar','Band'+IntToStr(i)+'Width',200);
			BandBreak[i]   :=
				ReadBool('Bar','Band'+IntToStr(i)+'Break',true);
		end;
      //c[o[\؂ւ
    	mnuShow_default.Checked:=ReadBool('Bar','ToolBar',True);
    	mnuShow_Address.Checked:=ReadBool('Bar','AddressBar',True);
      mnuShow_Status.Checked:=ReadBool('Bar','StatusBar',True);
      mnuShow_Tab.Checked:=ReadBool('Bar','TabBar',True);
      mnuShow_J.Checked:=ReadBool('Bar','JBar',True);
			//Jo[̃TCYݒ
      JBar.Width:=ReadInteger('Bar','JBarSize',153);
      btnBar.Tag:=ReadInteger('Bar','JBarMax',0);

	finally
		Free;
	end;

	CoolBar1.Bands.BeginUpdate;
	for i:=0 to BandCount-1 do
	begin//Band̈ʒuBreak𕜌܂B
		CoolBar1.Bands.FindItemID(BandIDNumber[i]).Index := i;
		CoolBar1.Bands[i].Break := BandBreak[i];
		CoolBar1.Bands[i].Control.Width := BandWidth[i];
	end;
	CoolBar1.Bands.EndUpdate;
end;

//CoolBar̈ʒȕ
procedure TMainForm.BandPositionWrite();
var
	ini: TIniFile;
	i: Integer;
begin
	Ini := TIniFile.Create(MyPath+'config.ini');
  with ini do
	try
		for i:=0 to BandCount-1 do
		begin//Band̈ʒuBreak
			WriteInteger('Bar','Band'+IntToStr(i)
					+'ID',CoolBar1.Bands[i].ID);
			WriteInteger('Bar','Band'+IntToStr(i)
          +'Width',CoolBar1.Bands[i].Control.Width);
			WriteBool('Bar','Band'+IntToStr(i)
          +'Break',CoolBar1.Bands[i].Break);
		end;
      //c[o[\؂ւ
    	WriteBool('Bar','ToolBar',mnuShow_default.Checked);
    	WriteBool('Bar','AddressBar',mnuShow_Address.Checked);
      WriteBool('Bar','StatusBar',mnuShow_Status.Checked);
      WriteBool('Bar','TabBar',mnuShow_Tab.Checked);
      WriteBool('Bar','JBar',mnuShow_J.Checked);
      WriteInteger('Bar','JBarSize',JBar.Width);
      WriteInteger('Bar','JBarMax',btnBar.Tag);
    finally
		Free;
	end;

end;

procedure TMainForm.JBarCreate();
//Jo[̍쐬
var
  tmpNode: TTreeNode;
  xmlDoc  :IXMLDOMDOCUMENT;
  DomName :IXMLDOMNode;
  xmlNode :IXMLDOMNode;
  i:byte;
begin

  //
  if TreeView1.Items.Count>0 then
  begin
  	for i:= 1 to fncCountChild(TreeView1.Items.Item[0]) do
    begin
  		TreeView1.TopItem.Delete;
    end;
  end;

  //XMLIuWFNg̍쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                          IXMLDOMDOCUMENT;
  xmlDoc.load('bookmark.xml');
  xmlDoc.documentElement  ;
  //m[ho^
  for i := 0 to xmlDoc.documentElement.childNodes.length-1 do
  begin
  DomName:=
    xmlDoc.documentElement.childNodes.item[i].firstChild;
  //m[h̃eLXgj[ɒǉ
   tmpNode:=TreeView1.Items.Add(nil,DomName.text);
  //ACR̕ύX
   tmpNode.ImageIndex:=11;
   tmpNode.SelectedIndex:=11;

  //fileAURLi[
    if DOMName.parentNode.baseName<>'directory' then begin
      xmlNode:=DOMName.Get_nextSibling;
      if i>=0 then
      begin
      //URLi[
      fncNodeItem
        (TreeView1.TopItem,i).Data2:=xmlNode.text;
      end;
     //ACR̕ύX
       tmpNode.ImageIndex:=12;
       tmpNode.SelectedIndex:=12;
    end else begin
      //URLi[
      tmpNode.Data2:= 'tH_';
		end;

  //Tuj[ǉ
  untBMB.mnuDir(DomName,tmpNode);
  end;
end;

procedure TMainForm.ViewToolBar();
begin
//c[o[̕\
	if mnuShow_default.Checked = False then
  										 ToolBar2.Visible:=False;
  if mnuShow_Address.Checked = False then
  										 ToolBar3.Visible:=False;
	if mnuShow_Status.Checked = False then
  										 ToolBar1.Visible:=False;
  if mnuShow_Tab.Checked = False then
  										 TabBar.Visible:=False;
  if mnuShow_J.Checked = False then
  										 JBar.Visible:=False;
end;

//̓ǂݍ
procedure TMainForm.ReadMojiSize();
var
	WinIni:TIniFile;
  tmpInt:Byte;
begin
	WinIni := TIniFile.Create(MyPath+'config.ini');
  tmpInt:=WinIni.ReadInteger('General','LastMojiSize',2);

  //w̕TCYɕύX
	case  tmpInt  of
   0: mnuSize_Min.Checked:=True;
   1: mnuSize_Small.Checked:=True;
   2: mnuSize_Middle.Checked:=True;
   3: mnuSize_Large.Checked:=True;
   4: mnuSize_Max.Checked:=True;
  end;

  intMojiSize:=tmpInt;
end;

//----------------Cxg----------------

procedure TMainForm.OnClickLeast_Item(Sender: TObject);
begin
  //GW̔f
  if IE_Item.Checked=True then begin
    CreateMDIChild('loading',TMenuItem(Sender).hint);
  end else begin
    CreateMDIChild('loading',TMenuItem(Sender).hint);
  end;
end;

procedure TMainForm.OnClickWebList_Item(Sender: TObject);
var
	i:Byte;
	WebLists:TStrings;
begin
//WebList_itemNbN
  //WebList̏
	WebLists:=TStringList.Create;
  //NbNACeǂݍ
  WebLists.LoadFromFile(MyPath+'WebList\'+TMenuItem(Sender).hint);

  //ǂݍ񂾃ACeɊJ
  for i:= 0 to WebLists.Count-1 do
  begin
		CreateMDIChild('londing',WebLists.Strings[i]);
  end;
 
end;

procedure TMainForm.iventMenuClick(Sender: TObject);
var
	WinIni:TIniFile;
  tmpInt:Byte;
Begin
//ubN}[NJ
 //tH_t@C𔻒f
	 if TMenuItem(Sender).hint<>'' then
   begin
   	//AhXo[URLLq
		  txtAddress.text:=TMenuItem(Sender).hint;

  	//VKEBhEŊJǂ
			WinIni := TIniFile.Create(MyPath+'config.ini');
  		tmpInt:=WinIni.ReadInteger('Option_Window','BookMark',0);
  		WinIni.Free;
  	//EBhEȂΐVKɂ
    	if self.MDIChildCount=0 then tmpInt:=1;

  	if tmpInt=1 then
  	begin
	 		//VKWindow쐬
   			CreateMDIChild('',txtAddress.text);
  	end else begin
    	//ANeButH[̔f
    	if self.ActiveMDIChild.Name='frm_ie' then begin
      	Tfrm_IE(ActiveMDIChild).TWeb_ie.Navigate(txtAddress.Text);
    	end else begin
      	Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Navigate(txtAddress.Text);
    	end;
  	end;
	end;
End;

procedure TMainForm.CreateMDIChild(const Name: string;const URL : string);
var
  Child1	: Tfrm_IE;
  Child2	: Tfrm_MZ;
var
  WinIni: TIniFile;
  strMoz:string;
  intMoz: Byte;
  tmpBool,TabBool:Bool;
  TabMaxLen,TabIndex2:Byte;
begin

  //JgfBNgMozillâtH_ɂB
   //MozillâpX擾
		WinIni := TIniFile.Create(MyPath+'config.ini');
  	strMoz:=Winini.ReadString('Option_Main','MozPath','');
    intMoz:=Winini.ReadInteger('Option_Main','Mozilla',0);
  //^u𐧌
		TabBool:=WinIni.ReadBool('Option_Tab','Len',False);
    TabMaxLen:=WinIni.ReadInteger('Option_Tab','MaxLen',0);


  tmpBool:=False;
	if TabBool=True then
  	if TabControl1.Tabs.Count=TabMaxLen then tmpBool:=True;
  if tmpBool=False then
	 begin
	  //Jg̐ݒ
	    if intMoz=1 then Chdir(strMoz);

	   { MDI qEBhE쐬 }
  	//^u֌W
      TabIndex2:=TabControl1.TabIndex;
  		intMDICount:=intMDICount+1;
  		strsTab.Add(IntToStr(intMDICount));
			TabControl1.Tabs.Add('loading');
	  //GW̔f
	  if IE_Item.Checked=True then begin
  	  Child1 := Tfrm_IE.Create(Application);
 	   	Child1.Caption := Name;
     	Child1.TWeb_IE.Navigate(URL);
  	  Child1.Tag:=intMDICount;
	  end else begin
    	Child2 := Tfrm_MZ.Create(Application);
  	  Child2.Caption := Name;
	    Child2.TWeb_MZ.Navigate(URL);
	    Child2.Tag:=intMDICount;
	  end;

    if Winini.ReadBool('Option_Window','NewWindow_Active',False)=True then
    begin
    //VK^uANeBuɂ
  		TabControl1.TabIndex:=TabControl1.Tabs.Count-1;
    end else begin
    //V^uJĂANeBuɂȂ
  		TabControl1.TabIndex:=TabIndex2;
    	TabControl1.OnChange(TabControl1);
  	end;
    WinIni.Free;
  end;

end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
//󔒂ŐVK쐬
  //GW̔f
  if IE_Item.Checked=True then begin
    CreateMDIChild('Internet Explorer','');
  end else begin
    CreateMDIChild('Gecko','about:blank');
  end;
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateMDIChild('',OpenDialog.FileName);
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  //Xe[^Xo[̃TCY`
  if ToolBar1.Width>260 then
  begin
    ProgressBar1.Width:=130;
    StatusBar1.Width:=ToolBar1.Width-130;
  end;
  //CoolBar̃TCY`
		btnMove.Left:=ToolBar3.Width-btnMove.Width;
		txtAddress.Width:=ToolBar3.Width-btnMove.Width
 																 -Label1.Width;
  //TabBar̃TCY`
  	TabControl1.Width:=TabBar.Width;
    TabControl1.Height:=TabBar.Height;

  //NȂHomePage\
  	if StartBool then
    begin
			CommandLine();
	    if comBool=False then HomePages();
  		//NȂMozilla̎gpL̊mF
  		if FileExists(MyPath+'config.ini')= False
    										then  mnuOption.OnClick(Sender);
    end;
    StartBool:=False;
end;

procedure TMainForm.txtAddressKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//AhXo[̃AhXŃy[WJ
 if key=13 then begin
	btnMove.OnClick(txtAddress);
 end;
end;

procedure TMainForm.ToolButton1Click(Sender: TObject);
begin
  //VK쐬
  FileNew1.Execute;
end;

procedure TMainForm.Moz_ItemClick(Sender: TObject);
begin
  Moz_item.Checked:=True;
  IE_Item.Checked:=False;
end;

procedure TMainForm.IE_itemClick(Sender: TObject);
begin
  IE_Item.Checked:=True;
  Moz_Item.Checked:=False;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
	WinIni: TIniFile;
begin
	//CloseList̏
 		CloseTabs:=TStringList.Create;
  //StartBool
  	StartBool:=True;
  //NpX擾
  	MyPath:=Application.Exename;
  	MyPath:=ExtractFilePath(MyPath);
  //^ȕ
  	intMDICount:=-1;
  	strsTab:=TStringList.Create;
  //CoolBar̈ʒuǂݍ
    BandPositionRead();
  //tH[\
   //	self.Show;
  //ubN}[Nǂݍ
  	ReadBookMark(); 

  //ŌɎgpGW
		WinIni := TIniFile.Create(MyPath+'config.ini');
    if Winini.ReadString('General','LastEngine','IE')='IE' Then
    begin
      IE_Item.Checked:=True;
  		Moz_Item.Checked:=False;
    end else begin
      Moz_item.Checked:=True;
  		IE_Item.Checked:=False;
    end;
  //Mozillagp邩ǂ
  	if Winini.ReadInteger('Option_Main','Mozilla',0)=0 then
    begin
    	Moz_item.Enabled:=False;
    end;
  //^uTCYŒ
		if WinIni.ReadInteger('Option_Tab','fix',0)=1 Then
    	 	TabControl1.TabWidth:=WinIni.ReadInteger('Option_Tab','MaxSize',75);
  //EBhETCY̌Œ
    case WinIni.ReadInteger('General','WinSize',0) of
    	0:WindowSize:=wsNormal;
      1:WindowSize:=wsMaximized;
      2:WindowSize:=wsMinimized;
    end;
  //^u^Cv̕ύX
  	if WinIni.ReadInteger('Option_Tab','TabType',0)=0 then
    begin
      TabControl1.Style:=tsTabs;
    	TabControl1.TabPosition:=tpBottom;
    end else begin
     	TabControl1.TabPosition:=tpTop;
      TabControl1.Style:=tsButtons;
    end;

  //IniFilẻ
    WinIni.Free;

  //JBar̐
		JBarCreate();
  //WebListǂݍ
    EnumFiles(MyPath+'WebList');
  //c[o[̕\
    ViewToolBar();
  //OtĕۑFalse
  	mnuFile_SaveAs.Enabled:=False;
  //TCYǂݍ
  	ReadMojiSize();
  //TCYFalse
  	mnuShow_Size.Enabled:=False;
	//keydownCxg
  	Application.OnMessage := HandleAppMessage;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
	WinIni: TIniFile;
	tmpStr:String;
  tmpInt:Byte;
begin
	if IE_item.Checked=True then begin
  	tmpStr:='IE';
  end else begin
  	tmpStr:='Gecko'
  end;
	//IniFileɌ݂̃GWo^
		WinIni := TIniFile.Create(MyPath+'config.ini');
  	WinIni.WriteString('General','LastEngine',tmpStr);
  //݂̕TCY
  	WinIni.WriteInteger('General','LastMojiSize',intMojiSize);
  //݂̃EBhETCY
    if WindowSize=wsNormal then tmpInt:=0;
    if WindowSize=wsMaximized then tmpInt:=1;
    if WindowSize=wsMinimized then tmpInt:=2;
    WinIni.WriteInteger('General','WinSize',tmpInt);

  	WinIni.Free;
	//CoolBar̈ʒu
    BandPositionWrite();

  //Ōɕ^u
  	CloseTabs.SaveToFile(MyPath+'Close.txt');

end;

procedure TMainForm.mnuBMEditClick(Sender: TObject);
begin
  if TreeView1.Selected<>nil then
  					TreeView1.Selected.Selected:=False;
  { ubN}[NGfB^\}
  frm_BMEdit.Show;
   //URL𑗂
   frm_BMEdit.txtURL.Text:=txtAddress.Text;
	 //O𑗂
	 frm_BMEdit.txtName.Text:=self.ActiveMDIChild.Caption;

end;

//߂
procedure TMainForm.BackCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
   if self.ActiveMDIChild<>nil then begin
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.GoBack;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.GoBack;
    end;
   end;
end;

//i
procedure TMainForm.FrwrdCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.GoForward;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.GoForward;
    end;
end;

//Xgbv
procedure TMainForm.StopCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.Stop;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Stop;
    end;
end;

//XV
procedure TMainForm.ReLoadCtrlClick(Sender: TObject);
begin
	//ANeButH[̔f
   if self.ActiveMDIChild<>nil then begin
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.Refresh;
    end else begin
      Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Refresh;
    end;
   end;
end;    

procedure TMainForm.mnuOptionClick(Sender: TObject);
var
	tmpForm:	Tfrm_Option;
begin
  //IvV\
   tmpForm := Tfrm_Option.Create(Application);
   tmpForm.Visible:=True;
end;

procedure TMainForm.btnMoveClick(Sender: TObject);
var
	WinIni:TIniFile;
  tmpInt:Byte;
	strURL:String;
Begin
//ړ{^
  //VKEBhEŊJǂ
		WinIni := TIniFile.Create(MyPath+'config.ini');
  	tmpInt:=WinIni.ReadInteger('Option_Window','AddressBar',0);
  	WinIni.Free;
  //EBhEȂΐVKɂ
    if self.MDIChildCount=0 then tmpInt:=1;
  //݂̃AhXo[ɋLqĂURLL
    strURL:=txtAddress.Text;

  if tmpInt=1 then
  begin
	 //VKWindow쐬
    FileNew1.Execute;
  end;

  //ANeButH[̔f
    if self.ActiveMDIChild.Name='frm_ie' then begin
      Tfrm_IE(ActiveMDIChild).TWeb_ie.Navigate(strURL);
    end else begin
     if strURL<>'' then Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Navigate(strURL);
    end;

end;


procedure TMainForm.CoolBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//AhX\̃TCYĒ`
	txtAddress.Width:=ToolBar3.Width-btnMove.Width
 																 -Label1.Width;
end;

procedure TMainForm.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
	tmpStr:String;
  WinIni:TIniFile;
  tmpInt:Byte;
begin
//Im[h̏\
	if Node<>nil then
  begin
  	tmpStr:=Node.Data2;

  	//ubN}[NJ
  	if tmpStr<>'tH_' then
  	begin
  	//AhXo[URLLq
		  txtAddress.text:=tmpStr;

  	//VKEBhEŊJǂ
			WinIni := TIniFile.Create(MyPath+'config.ini');
  		tmpInt:=WinIni.ReadInteger('Option_Window','BookMark',0);
  		WinIni.Free;
  	//EBhEȂΐVKɂ
    	if self.MDIChildCount=0 then tmpInt:=1;

  		if tmpInt=1 then
  		begin
	 			//VKWindow쐬
       	//Window
   				CreateMDIChild('',txtAddress.text);
  		end else begin
    		//ANeButH[̔f
    		if self.ActiveMDIChild.Name='frm_ie' then begin
      		Tfrm_IE(ActiveMDIChild).TWeb_ie.Navigate(txtAddress.Text);
    		end else begin
      		Tfrm_MZ(ActiveMDIChild).TWeb_MZ.Navigate(txtAddress.Text);
    		end;
  		end;
		end;
	end;
end;

procedure TMainForm.JBarResize(Sender: TObject);
begin
//c[TCY̒`
  TreeView1.Width:=JBar.Width-10;
  JBar.ButtonHeight:=JBar.Height;
  btnBar.Height:=10;
end;

procedure TMainForm.btnBarClick(Sender: TObject);
begin
//TCho[ŏ
  if btnBar.Tag=0 then
	begin
    btnBar.Tag:=JBar.Width;
  	JBar.Width:=11;
  end else begin
  	JBar.Width:=btnBar.Tag;
    btnBar.Tag:=0;
  end;
end;

procedure TMainForm.JBarMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if x<=11 then
  begin
	  JBar.Width:=11;
  end else begin
		JBar.Width:=x;
  end;  
end;

procedure TMainForm.mnuShow_defaultClick(Sender: TObject);
begin
//Wo[̕\؂ւ
	if mnuShow_default.Checked=True then
  begin
  	mnuShow_default.Checked:=False;
    ToolBar2.Visible:=False;
  end else begin
  	mnuShow_default.Checked:=True;
    ToolBar2.Visible:=True;
  end;
end;

procedure TMainForm.mnuShow_AddressClick(Sender: TObject);
begin
//AhXo[̕\؂ւ
	if mnuShow_Address.Checked=True then
  begin
    mnuShow_Address.Checked:=False;
  	ToolBar3.Visible:=False;
  end else begin
    mnuShow_Address.Checked:=True;
  	ToolBar3.Visible:=True;
  end;
end;

procedure TMainForm.mnuShow_StatusClick(Sender: TObject);
begin
//Xe[^Xo[̕\؂ւ
	if mnuShow_Status.Checked=True then
  begin
  	mnuShow_Status.Checked:=False;
    ToolBar1.Visible:=False;
  end else begin
  	mnuShow_Status.Checked:=True;
    ToolBar1.Visible:=True;
  end;
    
end;

procedure TMainForm.mnuShow_JClick(Sender: TObject);
begin
//Jo[̕\؂ւ
	if mnuShow_J.Checked=True then
  begin
  	mnuShow_J.Checked:=False;
    JBar.Visible:=False;
  end else begin
  	mnuShow_J.Checked:=True;
    JBar.Visible:=True;
  end;
end;

procedure TMainForm.mnuFile_SaveAsClick(Sender: TObject);
var
	c,d:olevariant;
begin
//Otĕۑ
	//gpGW̔f
	if self.ActiveMDIChild.Name='frm_ie' then begin
  	Tfrm_IE(ActiveMDIChild).TWeb_ie.ExecWB(OLECMDID_SAVEAS,
	          OLECMDEXECOPT_DONTPROMPTUSER,c,d);
  end else begin
    Tfrm_MZ(ActiveMDIChild).TWeb_MZ.ExecWB(OLECMDID_SAVEAS,0);
	end;
end;

procedure TMainForm.mnuSize_MaxClick(Sender: TObject);
var
  d:olevariant;
begin
  if Tfrm_IE(ActiveMDIChild).TWeb_ie.Busy=False then
  begin
		intMojiSize:=4;	//tHg̑傫
    Tfrm_IE(ActiveMDIChild).intMojiSize:=self.intMojiSize;

		Tfrm_IE(ActiveMDIChild).TWeb_ie.ExecWB(OLECMDID_ZOOM,
	          OLECMDEXECOPT_DONTPROMPTUSER,intMojiSize,d);

	  mnuSize_Max.Checked:=True;
	  mnuSize_Large.Checked:=False;
	  mnuSize_Middle.Checked:=False;
	  mnuSize_Small.Checked:=False;
	  mnuSize_Min.Checked:=False;
	end;
end;
procedure TMainForm.mnuSize_LargeClick(Sender: TObject);
var
  d:olevariant;
begin
  if Tfrm_IE(ActiveMDIChild).TWeb_ie.Busy=False then
  begin
		intMojiSize:=3;	//tHg̑傫
    Tfrm_IE(ActiveMDIChild).intMojiSize:=self.intMojiSize;

		Tfrm_IE(ActiveMDIChild).TWeb_ie.ExecWB(OLECMDID_ZOOM,
  	        OLECMDEXECOPT_DONTPROMPTUSER,intMojiSize,d);

  	mnuSize_Max.Checked:=False;
  	mnuSize_Large.Checked:=True;
  	mnuSize_Middle.Checked:=False;
  	mnuSize_Small.Checked:=False;
  	mnuSize_Min.Checked:=False;
	end;
end;

procedure TMainForm.mnuSize_middleClick(Sender: TObject);
var
  d:olevariant;
begin
	if Tfrm_IE(ActiveMDIChild).TWeb_ie.Busy=False then
  begin
		intMojiSize:=2;	//tHg̑傫
    Tfrm_IE(ActiveMDIChild).intMojiSize:=self.intMojiSize;

		Tfrm_IE(ActiveMDIChild).TWeb_ie.ExecWB(OLECMDID_ZOOM,
	          OLECMDEXECOPT_DONTPROMPTUSER,intMojiSize,d);

	  mnuSize_Max.Checked:=False;
	  mnuSize_Large.Checked:=False;
	  mnuSize_Middle.Checked:=True;
  	mnuSize_Small.Checked:=False;
	  mnuSize_Min.Checked:=False;
  end;
end;

procedure TMainForm.mnuSize_SmallClick(Sender: TObject);
var
  d:olevariant;
begin
	if Tfrm_IE(ActiveMDIChild).TWeb_ie.Busy=False then
  begin
  	intMojiSize:=1;	//tHg̑傫
    Tfrm_IE(ActiveMDIChild).intMojiSize:=self.intMojiSize;

		Tfrm_IE(ActiveMDIChild).TWeb_ie.ExecWB(OLECMDID_ZOOM,
    	      OLECMDEXECOPT_DONTPROMPTUSER,intMojiSize,d);

	  mnuSize_Max.Checked:=False;
	  mnuSize_Large.Checked:=False;
	  mnuSize_Middle.Checked:=False;
	  mnuSize_Small.Checked:=True;
	  mnuSize_Min.Checked:=False;
	end;
end;

procedure TMainForm.mnuSize_MinClick(Sender: TObject);
var
  d:olevariant;
begin
	if Tfrm_IE(ActiveMDIChild).TWeb_ie.Busy=False then
  begin
  	intMojiSize:=0;	//tHg̑傫
    Tfrm_IE(ActiveMDIChild).intMojiSize:=self.intMojiSize;

		Tfrm_IE(ActiveMDIChild).TWeb_ie.ExecWB(OLECMDID_ZOOM,
  	        		OLECMDEXECOPT_DONTPROMPTUSER,intMojiSize,d);

  	mnuSize_Max.Checked:=False;
  	mnuSize_Large.Checked:=False;
  	mnuSize_Middle.Checked:=False;
  	mnuSize_Small.Checked:=False;
  	mnuSize_Min.Checked:=True;
	end;
end;

procedure TMainForm.mnuEdit_slrAllClick(Sender: TObject);
var
	c,d:olevariant;
begin
//SđI
	//gpGW̔f
	if self.ActiveMDIChild.Name='frm_ie' then begin
  	Tfrm_IE(ActiveMDIChild).TWeb_IE.ExecWB(OLECMDID_SELECTALL,
  	        		OLECMDEXECOPT_DONTPROMPTUSER,c,d);
  end else begin
    Tfrm_MZ(ActiveMDIChild).TWeb_MZ.ExecWB(OLECMDID_SELECTALL,0);
	end;
end;

procedure TMainForm.mnuEdit_CopyClick(Sender: TObject);
var
	c,d:olevariant;
begin
//Rs[
	//gpGW̔f
	if self.ActiveMDIChild.Name='frm_ie' then begin
  	Tfrm_IE(ActiveMDIChild).TWeb_IE.ExecWB(OLECMDID_COPY,
  	        		OLECMDEXECOPT_DONTPROMPTUSER,c,d);
  end else begin
    Tfrm_MZ(ActiveMDIChild).TWeb_MZ.ExecWB(OLECMDID_COPY,0);
	end;
end;

procedure TMainForm.mnuShow_TabClick(Sender: TObject);
begin
//^uo[̕\؂ւ
	if mnuShow_Tab.Checked=True then
  begin
  	mnuShow_Tab.Checked:=False;
    TabBar.Visible:=False;
  end else begin
  	mnuShow_Tab.Checked:=True;
    TabBar.Visible:=True;
  end;
end;

procedure TMainForm.popTabCloseClick(Sender: TObject);
begin
  //^u
	TabClose(intTabIndex);
end;

procedure TMainForm.popAddCloseClick(Sender: TObject);
begin
	//^uCloseURLɒǉ
  TabAddClose(intTabIndex);
	TabClose(intTabIndex);
end;

procedure TMainForm.popAddBookMarkClick(Sender: TObject);
begin
	mnuBMEdit.OnClick(mnuBMEdit);
end;

procedure TMainForm.TabControl1Change(Sender: TObject);
begin
	untTab.TabChange(TabControl1.tabIndex);
end;

procedure TMainForm.TabControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	if Button<>mbLeft then	prcTabIndex();
end;

procedure TMainForm.TabControl1DrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
var
  s:string;
  r:TRect;
begin
//ANeBuȃ^u̐FύX
  s := TTabControl(Control).Tabs[TabIndex];
  r := Rect;

//^uF̐ݒ
  untTab.SetTabColor();
  with Control.Canvas do begin
    if Active then
    begin
    //ANeBuȃ^u
    	Brush.Color := untTab.TabColorBG1;
      Font.Color:= untTab.TabColorFont1;
		end else begin
    //ANeBułȂ^u
      Brush.Color :=untTab.TabColorBG2;
    	Font.Color:=untTab.TabColorFont2;
    end;
	//`ʒu̐ݒ
    //wïʒu
		Windows.FillRect(Handle,r,Brush.Handle);
    //eLXg̈ʒu
    r.Right:=r.Right-10;
		OffsetRect(r,8,1);
		DrawText(Handle,PChar(s),Length(s),r,
        	DT_Left or DT_SINGLELINE or DT_VCENTER or DT_END_ELLIPSIS );

  end;
end;


procedure TMainForm.HandleAppMessage(var Msg: TMsg; var Handled: Boolean);
begin
	if (Msg.hwnd = clientHandle) and (Msg.message = WM_KEYDOWN)
			and (Msg.wParam = VK_RETURN) then
	begin
		//ShowMessage('Return key');
		Handled := False;
	end;
end;


procedure TMainForm.mnuWebList_EditClick(Sender: TObject);
begin
	//WebList̕ҏW\
	 	frm_WebList.Show;
end;

procedure TMainForm.mnuNew_CilpClick(Sender: TObject);
begin
//Nbv{[hŐVK쐬
  //GW̔f
  if IE_Item.Checked=True then begin
    CreateMDIChild('Internet Explorer',Clipboard.AsText);
  end else begin
    CreateMDIChild('Gecko',Clipboard.AsText);
  end;
end;

procedure TMainForm.mnu_AllCloseClick(Sender: TObject);
var
	i,f:Byte;
begin
//SẴEBhE
 	f:=0;
  TabCloseAll:=True;

	for i:= 0 to MainForm.MDIChildCount-1 do
  begin
	  TabClose(f);
  end;

end;

procedure TMainForm.mnu_AllCloseNotMeClick(Sender: TObject);
var
	i,f:Byte;
begin
//ȊȎSẴEBhE
 	f:=0;

  //^uȂȂ
  if self.MDIChildCount<>1 then
  begin
		for i:= 0 to MainForm.MDIChildCount-2 do
  	begin
    	if i=intTabIndex then f:=1;
	  	TabClose(f);
  	end;
  end;  

end;

procedure TMainForm.mnuLeastURLClick(Sender: TObject);
var
	tmpMenu:TMenuItem;
  i:Byte;
begin
//ŋߕURL
  //
  if mnuLeastURL.Count>0 then
  begin
  	for i:=1 to mnuLeastURL.Count-1 do
    begin
    	mnuLeastURL.Delete(0);
    end;
  end;

  //
  if CloseTabs.Count<>0 then
  begin
  	for i:=0 to CloseTabs.Count-1 do
		begin
			tmpMenu:=AddMenu(mnuLeastURL,'&'+intTostr(i+1)+'D'+CloseTabs.Strings[i],i);
			tmpMenu.Hint:=CloseTabs.Strings[i];
    	tmpMenu.OnClick:=OnClickLeast_Item;
    end;
  end;
end;

end.
