unit BookMark;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MSXML_TLB, StdCtrls,ComObj, ImgList, ExtCtrls, Menus, ComCtrls;

type
  Tfrm_BMEdit = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    txtURL: TEdit;
    btnCancel: TButton;
    btnAdd: TButton;
    btnMD: TButton;
    TreeView1: TTreeView;
    txtName: TEdit;
    btnOK: TButton;
    ImageList1: TImageList;
    btnDel: TButton;
    btnSubMD: TButton;
    btnEdit: TButton;
    PopupMenu1: TPopupMenu;
    popEdit: TMenuItem;
    popReName: TMenuItem;
    popMoveUp: TMenuItem;
    popMoveDown: TMenuItem;
    popDel: TMenuItem;
    M1: TMenuItem;
    N1: TMenuItem;
    procedure btnCancelClick(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnMDClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure btnSubMDClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure popEditClick(Sender: TObject);
    procedure popReNameClick(Sender: TObject);
    procedure popMakeSubClick(Sender: TObject);
    procedure popDelClick(Sender: TObject);
    procedure popMoveDownClick(Sender: TObject);
    procedure popMoveUpClick(Sender: TObject);

  private
    { Private 錾 }
    sltNode : TTreeNode;
  public
    { Public 錾 }

  end;

var
  frm_BMEdit: Tfrm_BMEdit;

implementation

uses MAIN;

{$R *.DFM}
//֐

//item]bg쐬
function fncNodeItem(tmpNode:TTreeNode;f:Byte):TTreeNode;
var
  i:Byte;
begin
 for i:= 1 to f do
 begin
		tmpNode:=tmpNode.getNextSibling;
 end;

	Result:=tmpNode;

end;

//TufBNg`FbN
function  mnuDir(tmpXMLNode:IXMLDOMNode ; xmlMenu:TTreeNode):IXMLDOMNode;
var
  tmpMenu: TTreeNode;//̃j[
  tmpNode:IXMLDOMNode;
  i:byte;
begin
  //`hJԂ
  for i := 1 to tmpXMLNode.parentNode.childNodes.length-1 do
  begin
    if tmpXMLNode.parentNode.Get_nodeName='directory' then begin
      //TufBNg
      tmpNode:=tmpXMLNode.parentNode.childNodes.item[i].firstChild;
      tmpMenu:=frm_BMEdit.TreeView1.Items.AddChild(xmlMenu,tmpNode.text );
      //ACR̕ύX
        tmpMenu.ImageIndex:=0;
        tmpMenu.SelectedIndex:=0;

        //fileAURL
          if tmpNode.parentNode.baseName<>'directory' then begin
            tmpMenu.Data2:=tmpNode.parentNode.lastChild.text;
            //ACR̕ύX
              tmpMenu.ImageIndex:=1;
              tmpMenu.SelectedIndex:=1;
          end else begin
            //URL̊i[
              tmpMenu.Data2:='tH_';
          end;
      //fBNg΂xJ
      if tmpNode.parentNode.baseName='directory' then mnuDir(tmpNode,tmpMenu);
    end;
  end;
end;

//`h𐔂
function fncCountChild(Node:TTreeNode):integer;
var
  tmpNode:TTreeNode;
  f:Byte;
begin
  //f̏
    f:=0;
  //`
    while tmpNode <> nil do
    begin
      tmpNode:= tmpNode.getNextSibling;
      f:=f+1;
    end;
  //߂l
    Result:=f;
end;

//葱

procedure subAddFile(tmpNode:IXMLDOMNode; f:Byte;
                     tmpName:string;tmpURL:string);
var
  XMLDoc : IXMLDOMDOCUMENT;
  xmlNode   : IXMLDOMNode;
  paragraph : IXMLDOMNode;
  pph : String;
  i : Byte;
begin
  //XMLDocument쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                        IXMLDOMDOCUMENT;

  //sCfgi/rootj
    for i:=1 to f do begin pph:=pph+'  'end;
    paragraph:=XMLDOC.createTextNode(#10+pph);
    tmpNode.appendChild(paragraph);
    pph:='';
  //<file>쐬
    xmlNode:=xmldoc.createElement('file');
    tmpNode.appendChild(xmlNode);
    //sCfgi/filej
      for i:=1 to f+1 do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';

  //<name>쐬
    xmlNode:=xmldoc.createElement('name');
    xmlNode.text:=tmpName;
    tmpNode.lastChild.appendChild(xmlNode);
    //sCfgi/namej
      for i:=1 to f+1 do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';

  //<url>쐬
    XMLNode:=XMLDoc.createElement('url');
    XMLNode.text:=tmpURL;
    tmpNode.lastchild.appendChild(XMLNode);
    //sCfgi/urlj
      for i:=1 to f do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';
end;

//fBNg̍쐬
procedure subAddDir(tmpNode:IXMLDOMNode; f:Byte;
                     tmpName:string);
var
  XMLDoc : IXMLDOMDOCUMENT;
  xmlNode   : IXMLDOMNode;
  paragraph : IXMLDOMNode;
  pph : String;
  i : Byte;
begin
  //XMLDocument쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                        IXMLDOMDOCUMENT;

  //sCfgi/rootj
    if f=1 then
    begin
    for i:=1 to f do begin pph:=pph+'  'end;
    end else begin
    for i:=1 to f-1 do begin pph:=pph+'  'end;
    end;
     //TufBNgȂXy[XȂB
      paragraph:=XMLDOC.createTextNode(#10+pph);

    tmpNode.appendChild(paragraph);
    pph:='';
  //<directory>쐬
    xmlNode:=XMLdoc.createElement('directory');
    tmpNode.appendChild(xmlNode);
    //sCfgi/directoryj
      for i:=1 to f+1 do begin pph:=pph+'  'end;
      paragraph:=XMLDOC.createTextNode(#10+pph);
      tmpNode.lastChild.appendChild(paragraph);
      pph:='';
  //<name>쐬
    xmlNode:=XMLdoc.createElement('name');
    xmlNOde.text:=tmpName;
    tmpNode.lastChild.appendChild(xmlNode);

end;

//XMLt@C̐
procedure subMKXML(tmpNode:TTreeNode;tmpXML:IXMLDOMNode);
var
  i:Byte;
begin
   for i:=0 to fncCountChild(tmpNode)-1 do
   begin
    //tH_t@C`FbN
    if tmpNode.Count=0 then
    begin
      subAddFile(tmpXML,tmpNode.Level+2 ,
        tmpNode.Text,tmpNode.Data2);

    end else begin
      subAddDir(tmpXML,tmpNode.Level+2,
        tmpNode.Text);
      //TufBNgǉ
      subMKXML(tmpNode.Item[0],tmpXML.lastChild)
    end;
    //̃m[h֍s
    tmpNode:= tmpNode.getNextSibling;
   end;
end;


//----------------Cxg----------------
procedure Tfrm_BMEdit.FormCreate(Sender: TObject);
var
  tmpNode: TTreeNode;
  xmlDoc  :IXMLDOMDOCUMENT;
  DomName :IXMLDOMNode;
  xmlNode :IXMLDOMNode;
  i:byte;
begin

  //
  if TreeView1.Items.Count>0 then
  begin
  	for i:= 1 to fncCountChild(TreeView1.Items.Item[0]) do
    begin
  		TreeView1.TopItem.Delete;
    end;
  end;

  //XMLIuWFNg̍쐬
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                          IXMLDOMDOCUMENT;
  xmlDoc.load('bookmark.xml');
  xmlDoc.documentElement  ;
  //m[ho^
  for i := 0 to xmlDoc.documentElement.childNodes.length-1 do
  begin
  DomName:=
    xmlDoc.documentElement.childNodes.item[i].firstChild;
  //m[h̃eLXgj[ɒǉ
   tmpNode:=TreeView1.Items.Add(nil,DomName.text);
  //ACR̕ύX
   tmpNode.ImageIndex:=0;
   tmpNode.SelectedIndex:=0;

  //fileAURLi[
    if DOMName.parentNode.baseName<>'directory' then begin
      xmlNode:=DOMName.Get_nextSibling;
      if i>=0 then
      begin
      //URLi[
      fncNodeItem
        (TreeView1.TopItem,i).Data2:=xmlNode.text;
      end;
     //ACR̕ύX
       tmpNode.ImageIndex:=1;
       tmpNode.SelectedIndex:=1;
    end else begin
      //URLi[
      tmpNode.Data2:= 'tH_';
		end;

  //Tuj[ǉ
  mnuDir(DomName,tmpNode);
  end;
end;

procedure Tfrm_BMEdit.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
	sltNode:=Node;
{  //fobNp
  txtURL.text:=memo1.lines.Strings[Node.AbsoluteIndex];
  txtName.Text:=node.text;}
end;

//URL̒ǉ
procedure Tfrm_BMEdit.btnAddClick(Sender: TObject);
var
  tmpNode:TTreeNode;//쐬m[h
  tmpNode2:TTreeNode;//ړm[h
  tmpNode3:TTreeNode;//`h
begin
  //NodȇI𔻒f
  if sltNode=nil then begin
    sltNode:=TreeView1.TopItem;
  end;

  //tH_Ȃqɂ
  if sltNode.ImageIndex=0 then
  begin
    //tH_ɎqȂꍇ
    if sltNode.Count=0 then begin
    	tmpNode3:=TreeView1.Items.AddChildFirst(TreeView1.Selected,'123');
    end else begin
    	tmpNode3:=tmpNode2;
    end;
  	tmpNode2:=sltNode.getFirstChild;
  end else begin
    //oOp
    	tmpNode3:=tmpNode2;
      tmpNode2:=sltNode;
  end;

  //t@C̍쐬
    tmpNode:=TreeView1.Items.Add(TreeView1.Selected,txtName.Text);
  //ACR̕ύX
    tmpNode.ImageIndex:=1;
    tmpNode.SelectedIndex:=1;

  //URLf[^̍쐬
    tmpNode.data2:=txtURL.Text;
  //t@C̈ړ
    tmpNode.MoveTo(tmpNode2,naInsert);

  //`h̍폜
    tmpNode3.Delete;

end;

//m[h̍폜
procedure Tfrm_BMEdit.btnDelClick(Sender: TObject);
begin
	sltNode.Delete;
end;

//tH_̍쐬
procedure Tfrm_BMEdit.btnMDClick(Sender: TObject);
var
  tmpNode:TTreeNode;//쐬m[h
  tmpNode2:TTreeNode;//ړm[h
  tmpNode3:TTreeNode;//`h
begin
  //NodȇI𔻒f
  if sltNode=nil then begin
    sltNode:=TreeView1.TopItem;
  end;
  //oOp
   	tmpNode3:=tmpNode2;
     tmpNode2:=sltNode;

  //t@C̍쐬
    tmpNode:=TreeView1.Items.Add(TreeView1.Selected,'VtH_');
  //ACR̕ύX
    tmpNode.ImageIndex:=0;
    tmpNode.SelectedIndex:=0;

  //URLf[^̍쐬
    tmpNode.Data2:=txtURL.Text;
  //t@C̈ړ
    tmpNode.MoveTo(tmpNode2,naInsert);

  //`h̍폜
    tmpNode3.Delete;

  //tH_ύX
  	tmpNode.EditText;
end;

//ubN}[NXVďI
procedure Tfrm_BMEdit.btnOKClick(Sender: TObject);
var
  XMLDoc : IXMLDOMDOCUMENT;
  paragraph : IXMLDOMNode;
  procinst  : IXMLDOMProcessingInstruction;
  tmpNode : TTreeNode;
  i:byte;
begin
  XMLdoc := CreateOleObject('MSXML.DOMDocument') As
                                          IXMLDOMDOCUMENT;
  //XML錾
    procinst := XMLdoc.createProcessingInstruction( 'xml',
           'version="1.0" encoding="Shift_JIS"' );
    XMLdoc.appendChild( procinst );
  //[g쐬
   XMLDoc.documentElement:=XMLdoc.createElement('bookmark');

  //tmpNodȅ
    tmpNode:=TreeView1.Items.Item[0];
  //qNodeǉ     
   for i:=0 to fncCountChild(tmpNode)-1 do
   begin
    //tH_t@C`FbN
    if tmpNode.Count=0 then
    begin
      subAddFile(XMLDoc.documentElement,1,
        tmpNode.Text,tmpNode.Data2);

    end else begin
      subAddDir(XMLDoc.documentElement,1,
        tmpNode.Text);
      //TufBNgǉ
      subMKXML(tmpNode.Item[0],XMLDoc.documentElement.lastChild)
    end;
    //̃m[h֍s
    tmpNode:= tmpNode.getNextSibling;
   end;

 	//sCfgi/bookmarkj
    paragraph:=XMLDOC.createTextNode(#10);
    XMLDoc.documentElement.appendChild(paragraph);

  //t@Co
	  XMLDoc.save('BookMark.xml');

	//ubN}[Nǂݍ
	  MainForm.ReadBookMark();
  	MainForm.JBarCreate();

  //I
		self.Close;
end;

//ubN}[NXVɏI
procedure Tfrm_BMEdit.btnCancelClick(Sender: TObject);
begin
  self.OnCreate(self);
	self.Close;
end;



procedure Tfrm_BMEdit.btnSubMDClick(Sender: TObject);
var
  tmpNode:TTreeNode;//쐬m[h
  tmpNode2:TTreeNode;//ړm[h
  tmpNode3:TTreeNode;//`h
begin
  //NodȇI𔻒f
  if sltNode=nil then begin
    sltNode:=TreeView1.TopItem;
  end;

  //tH_Ȃqɂ
  if sltNode.ImageIndex=0 then
  begin
    //tH_ɎqȂꍇ
    if sltNode.Count=0 then begin
    	tmpNode3:=TreeView1.Items.AddChildFirst(TreeView1.Selected,'123');
    end else begin
    	tmpNode3:=tmpNode2;
    end;
  	tmpNode2:=sltNode.getFirstChild;


  //t@C̍쐬
    tmpNode:=TreeView1.Items.Add(TreeView1.Selected,'VtH_');
  //ACR̕ύX
    tmpNode.ImageIndex:=0;
    tmpNode.SelectedIndex:=0;

  //URLf[^̍쐬
    tmpNode.data2:='tH_';
  //t@C̈ړ
    tmpNode.MoveTo(tmpNode2,naInsert);

  //`h̍폜
    tmpNode3.Delete;

  //tH_ύX
  	tmpNode.EditText;
  end;
end;

procedure Tfrm_BMEdit.btnEditClick(Sender: TObject);
var
	tmpInt:Byte;
begin
  //NodȇI𔻒f
  if sltNode=nil then begin
    sltNode:=TreeView1.TopItem;
  end;

  tmpInt:=sltNode.AbsoluteIndex;

  //t@CtH_f
  if sltNode.ImageIndex=1 then
  begin
    //ҏW
		sltNode.Data2:=InputBox('ҏW', sltNode.Text,
    																				sltNode.Data2);
  end;
end;

procedure Tfrm_BMEdit.PopupMenu1Popup(Sender: TObject);
begin
	TreeView1.Selected:=TreeView1.Selected;
end;

procedure Tfrm_BMEdit.popEditClick(Sender: TObject);
begin
	btnEdit.OnClick(btnEdit);
end;

procedure Tfrm_BMEdit.popReNameClick(Sender: TObject);
begin
	//O̕ύX
	sltNode.EditText;
end;

procedure Tfrm_BMEdit.popMakeSubClick(Sender: TObject);
begin
	btnSubMD.OnClick(btnSubMD);
end;

procedure Tfrm_BMEdit.popDelClick(Sender: TObject);
begin
	btnDel.OnClick(btnDel);
end;

procedure Tfrm_BMEdit.popMoveDownClick(Sender: TObject);
var
  i:Byte;
	tmpBool:Bool;
  tmpNode:TTreeNode;
begin
//ACeɈړ
	tmpBool:=False;

  tmpNode:=TreeView1.TopItem;
	for i:= 2 to fncCountChild(TreeView1.TopItem) do
  begin
    	tmpNode:=tmpNode.getNextSibling;
	end;

  //IACeŉʂf
	if TreeView1.Selected=tmpNode then tmpBool:=True;

  if TreeView1.Selected.Parent<>nil then
  begin
	  if TreeView1.Selected=TreeView1.Selected
  									.Parent.GetLastChild then	tmpBool:=True;
	end;

	if tmpBool=False then
	begin
		//Ɉړ
		TreeView1.Selected.getNextSibling
  									.MoveTo(TreeView1.Selected,naInsert);
  end else begin
  	beep;
	end;

end;

procedure Tfrm_BMEdit.popMoveUpClick(Sender: TObject);
var
	tmpBool:Bool;
begin
//ACeɈړ
 	tmpBool:=False;

  //IACeŏʂf
	if TreeView1.Selected=TreeView1.TopItem then tmpBool:=True;

  if TreeView1.Selected.Parent<>nil then
  begin
	  if TreeView1.Selected=TreeView1.Selected
  									.Parent.getFirstChild then tmpBool:=True;
	end;

	if tmpBool=False then
	begin
		//Ɉړ
		TreeView1.Selected
  			.MoveTo(TreeView1.Selected.getPrevSibling,naInsert);
  end else begin
  	beep;
 	end;
end;

end.

