unit Option;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SHBFFEX, Buttons ,IniFiles, ComCtrls, ExtCtrls;

type
  Tfrm_Option = class(TForm)
    selectFolder: TSHBrowseForFolderEx;
    TreeView1: TTreeView;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    PageCTL: TPageControl;
    TabSheet1: TTabSheet;
    txtMozPath: TEdit;
    chkMoz: TCheckBox;
    BitBtn1: TBitBtn;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    chkWin1: TCheckBox;
    chkWin2: TCheckBox;
    TabSheet3: TTabSheet;
    chkPop: TCheckBox;
    PopList: TMemo;
    TabSheet4: TTabSheet;
    chkTabSize: TCheckBox;
    txtTabSize: TEdit;
    UpDown1: TUpDown;
    Label2: TLabel;
    chkTabLen: TCheckBox;
    Label3: TLabel;
    txtTabLen: TEdit;
    UpDown2: TUpDown;
    chkActive3: TCheckBox;
    Label5: TLabel;
    cmbTabType: TComboBox;
    ColorPanel1: TPanel;
    ColorPanel2: TPanel;
    Label4: TLabel;
    Label6: TLabel;
    ChColor2: TLabel;
    BGColor1: TLabel;
    BGColor2: TLabel;
    ColorDialog1: TColorDialog;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    ChColor1: TLabel;
    TabSheet5: TTabSheet;
    txtStartPath: TEdit;
    radNone: TRadioButton;
    radURL: TRadioButton;
    radWebList: TRadioButton;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure chkMozClick(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure chkTabSizeClick(Sender: TObject);
    procedure chkTabLenClick(Sender: TObject);
    procedure ChColor1Click(Sender: TObject);
    procedure BGColor1Click(Sender: TObject);
    procedure BGColor2Click(Sender: TObject);
    procedure ChColor2Click(Sender: TObject);
    procedure radWebListClick(Sender: TObject);
    procedure radURLClick(Sender: TObject);
    procedure radNoneClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
	private
    { Private 錾 }
    strPath:string;
    chkStart:Byte;
  public
    { Public 錾 }
    procedure ReadIni();
  end;

var
  frm_Option: Tfrm_Option;

implementation
uses Main;

{$R *.DFM}

procedure Tfrm_Option.ReadIni();
var
	WinIni: TIniFile;
begin
  //IniFileIvVǂݍ
		WinIni := TIniFile.Create(strPath+'config.ini');

    //Mozillagp邩ǂ
      if Winini.ReadInteger('Option_Main','Mozilla',0)=0 then
      begin
        //gp
      	chkMoz.Checked:=False;
      end else begin
        //gpȂ
      	chkMoz.Checked:=True;
      end;
      chkMoz.OnClick(chkMoz);
    	//MozillâpX
  			txtMozPath.text:=Winini.ReadString('Option_Main','MozPath','');


    //VKEBhE
      //ANeBuɂ邩ǂ
      chkActive3.Checked:=Winini.ReadBool('Option_Window','NewWindow_Active',False);
      //ubN}[N
    	chkWin1.Checked:=WinIni.ReadBool('Option_Window','BookMark',False);
      //AhXo[
      chkWin2.Checked:=WinIni.ReadBool('Option_Window','AddressBar',False);
    //CloseURL@\gp邩ǂ
     	chkPop.Checked:=Winini.ReadBool('Option_advertisemen','CloseURL',False);

    //^u
      //^uTCY
      if Winini.ReadBool('Option_Tab','fix',False)=False then
      begin
        //gp
      	chkTabSize.Checked:=False;
      end else begin
        //gpȂ
      	chkTabSize.Checked:=True;
      end;
      UpDown1.Position:=WinIni.ReadInteger('Option_Tab','MaxSize',75);
      chkTabSize.OnClick(chkTabSize);

      //^u𐧌
      if Winini.ReadBool('Option_Tab','Len',False)=False then
      begin
        //gp
      	chkTabLen.Checked:=False;
      end else begin
        //gpȂ
      	chkTabLen.Checked:=True;
      end;
      UpDown2.Position:=WinIni.ReadInteger('Option_Tab','MaxLen',0);
      chkTabLen.OnClick(chkTabLen);

      //^u̎
      cmbTabType.ItemIndex:=WinIni.ReadInteger('Option_Tab','TabType',0);

      //^u̐F
    	//ANeBũ^u̐F
      ChColor1.Color:=StringToColor(WinIni.ReadString('Option_Tab',
      																		'ActivateChColor','clWindowText'));
      BGColor1.Color:=StringToColor(Winini.ReadString('Option_Tab',
      																		'ActivateBGColor','clBtnFace'));
    	//ANeBũ^u̐F
      ChColor2.Color:=StringToColor(WinIni.ReadString('Option_Tab',
      																		'DeActivateChColor','clWindowText'));
      BGColor2.Color:=StringToColor(Winini.ReadString('Option_Tab',
      																		'DeActivateBGColor','clBtnFace'));
      //pl̐FύX
      	ColorPanel1.Font.Color:=ChColor1.Color;
      	ColorPanel2.Font.Color:=ChColor2.Color;
      	ColorPanel1.Color:=BGColor1.Color;
      	ColorPanel2.Color:=BGColor2.Color;

 			//X^[gAbv
			chkStart:=WinIni.ReadInteger('Option_StartUp','Type',0);
      case chkStart of
      	0:radNone.Checked:=True;
        1:radURL.Checked:=True;
        2:radWebList.Checked:=True;
      end;
      txtStartPath.Text:=WinIni.ReadString('Option_StartUp','Path','');

  //iniFile
    WinIni.Free;
end;

procedure Tfrm_Option.FormCreate(Sender: TObject);
var
  SheetIndex:Byte;
begin
  //JgpX擾
	strPath:=MainForm.MyPath;

  //IniFileIvVǂݍ
  ReadIni();

	//^u\ɂ
	for SheetIndex:= 1 to 5 do begin
		TTabSheet(FindComponent('TabSheet' + IntToStr(SheetIndex)))
					.TabVisible:=False;
  end;

  //Fݒ肷
  self.Color:=clbtnFace;

  //CloseURL̓ǂݍ
  PopList.Lines.LoadFromFile(MainForm.MyPath+'CloseURL.txt');

  //ԏ̃^uI
  TreeView1.TopItem.Selected:=True;
  TreeView1.Items.Item[1].Expanded:=True;

end;

procedure Tfrm_Option.BitBtn1Click(Sender: TObject);
begin
  //tH_Q
	if selectFolder.Execute then
  		txtMozPath.Text:=selectFolder.FolderName;
end;

//OK̏
procedure Tfrm_Option.Button1Click(Sender: TObject);
var
  WinIni: TIniFile;
begin

  //IniFileɃIvV
		WinIni := TIniFile.Create(Main.MainForm.MyPath+'config.ini');
    //Mozilla̎gp
  		WinIni.WriteString('Option_Main','MozPath',txtMozPath.text);
    	WinIni.WriteInteger('Option_Main','Mozilla',chkMoz.tag);
    //VKŊJEChE
    	WinIni.WriteBool('Option_Window','BookMark',chkWin1.Checked);
			WinIni.WriteBool('Option_Window','AddressBar',chkWin2.Checked);
      WinIni.WriteBool('Option_Window','NewWindow_Active',chkActive3.Checked);
    //CloseURL@\
    	WinIni.WriteBool('Option_advertisemen','CloseURL',chkPop.Checked);
    //^uTCY
    	WinIni.WriteBool('Option_Tab','fix',chkTabSize.Checked);
			WinIni.WriteInteger('Option_Tab','MaxSize',StrToInt(txtTabSize.Text));
    //^u̐
    	WinIni.WriteBool('Option_Tab','Len',chkTabLen.Checked);
			WinIni.WriteInteger('Option_Tab','MaxLen',StrToInt(txtTabLen.Text));
    //^u̎
    	WinIni.WriteInteger('Option_Tab','TabType',cmbTabType.ItemIndex);
    //ANeBũ^u̐F
      WinIni.WriteString('Option_Tab','ActivateChColor',ColorToString(ChColor1.Color));
      Winini.WriteString('Option_Tab','ActivateBGColor',ColorToString(BGColor1.Color));
    //ANeBũ^u̐F
      WinIni.WriteString('Option_Tab','DeActivateChColor',ColorToString(ChColor2.Color));
      Winini.WriteString('Option_Tab','DeActivateBGColor',ColorToString(BGColor2.Color));
    //X^[gAbv
			WinIni.WriteInteger('Option_StartUp','Type',chkStart);
      WinIni.WriteString('Option_StartUp','Path',txtStartPath.text);

//--ǂݍ
  //^uTCYŒ
		if WinIni.ReadInteger('Option_Tab','fix',0)=1 Then
    	 	MainForm.TabControl1.TabWidth:=WinIni.ReadInteger('Option_Tab','MaxSize',75);
  //^u^Cv̕ύX
  	if WinIni.ReadInteger('Option_Tab','TabType',0)=0 then
    begin
      MainForm.TabControl1.Style:=tsTabs;
    	MainForm.TabControl1.TabPosition:=tpBottom;
    end else begin
     	MainForm.TabControl1.TabPosition:=tpTop;
      MainForm.TabControl1.Style:=tsButtons;
    end;
  	WinIni.Free;
  //CloseURL̃Xgۑ
  	PopList.Lines.SaveToFile(MainForm.MyPath+'CloseURL.txt');
  //tH[
  	self.Close;  
end;



procedure Tfrm_Option.Button2Click(Sender: TObject);
begin
	self.Close;
end;

procedure Tfrm_Option.chkMozClick(Sender: TObject);
begin
	if chkMoz.Checked=True then
  begin
    chkMoz.tag:=1;
  	txtMozPath.Enabled:=True;
    txtMozPath.Color:=clCaptionText;
    BitBtn1.Enabled:=True;
    MainForm.Moz_item.Enabled:=True;
  end else begin
  	txtMozPath.Enabled:=False;
    txtMozPath.Color:=clInactiveBorder;
    BitBtn1.Enabled:=False;
    chkMoz.tag:=0;
    MainForm.Moz_item.Enabled:=False;
  end;
end;

procedure Tfrm_Option.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
 //IvV؂ւ
	if Node.Text='S' then
  begin
		TabSheet1.Show;
  end else
  if Node.Text='EBhE' then
  begin
  	TabSheet2.Show;
  end else
  if Node.Text='L}~' then
  begin
  	TabSheet3.Show;
  end else
  if Node.Text='^u' then
  begin
  	TabSheet4.Show;
  end;
  if Node.Text='X^[gAbv' then
  begin
  	TabSheet5.Show;
  end;

end;

procedure Tfrm_Option.chkTabSizeClick(Sender: TObject);
begin
	if chkTabSize.Checked=True then
  begin
		UpDown1.Enabled:=True;
  	txtTabSize.Enabled:=True;
    txtTabSize.Color:=clCaptionText;
  end else begin
		UpDown1.Enabled:=False;
  	txtTabSize.Enabled:=False;
    txtTabSize.Color:=clInactiveBorder;
  end;
end;

procedure Tfrm_Option.chkTabLenClick(Sender: TObject);
begin
	if chkTabLen.Checked=True then
  begin
		UpDown2.Enabled:=True;
  	txtTabLen.Enabled:=True;
    txtTabLen.Color:=clCaptionText;
  end else begin
		UpDown2.Enabled:=False;
  	txtTabLen.Enabled:=False;
    txtTabLen.Color:=clInactiveBorder;
  end;
end;

procedure Tfrm_Option.ChColor1Click(Sender: TObject);
begin
	//ANeBu^u̕FύX
  	if ColorDialog1.Execute then
    begin
    	ChColor1.Color:=ColorDialog1.Color;
      ColorPanel1.Font.Color:=ChColor1.Color;
      ColorPanel1.Color:=BGColor1.Color;
    end;
end;

procedure Tfrm_Option.BGColor1Click(Sender: TObject);
begin
	//ANeBu^u̔wiFύX
  	if ColorDialog1.Execute then
    begin
    	BGColor1.Color:=ColorDialog1.Color;
      ColorPanel1.Font.Color:=ChColor1.Color;
      ColorPanel1.Color:=BGColor1.Color;
    end;
end;

procedure Tfrm_Option.BGColor2Click(Sender: TObject);
begin
	//ANeBu^u̔wiFύX
  	if ColorDialog1.Execute then
    begin
    	BGColor2.Color:=ColorDialog1.Color;
      ColorPanel2.Font.Color:=ChColor2.Color;
      ColorPanel2.Color:=BGColor2.Color;
    end;
end;

procedure Tfrm_Option.ChColor2Click(Sender: TObject);
begin
	//ANeBu^u̕FύX
  	if ColorDialog1.Execute then
    begin
    	ChColor2.Color:=ColorDialog1.Color;
      ColorPanel2.Font.Color:=ChColor2.Color;
      ColorPanel2.Color:=BGColor2.Color;
    end;
end;

procedure Tfrm_Option.radWebListClick(Sender: TObject);
begin
//w肵WebXg`FbN
	chkStart:=2;
	txtStartPath.Enabled:=True;
  txtStartPath.Color:=clCaptionText;
  BitBtn2.Enabled:=True;
end;

procedure Tfrm_Option.radURLClick(Sender: TObject);
begin
//w肵URL
	chkStart:=1;
	txtStartPath.Enabled:=True;
  txtStartPath.Color:=clCaptionText;
  BitBtn2.Enabled:=False;

end;

procedure Tfrm_Option.radNoneClick(Sender: TObject);
begin
//JȂ`FbN
	chkStart:=0;
	txtStartPath.Enabled:=False;
  txtStartPath.Color:=clInactiveBorder;
  BitBtn2.Enabled:=False;
end;

procedure Tfrm_Option.BitBtn2Click(Sender: TObject);
begin
//wlfJ
  OpenDialog1.InitialDir:=MainForm.MyPath+'WebList';
	if OpenDialog1.Execute then
  		txtStartPath.Text:=OpenDialog1.FileName;
end;

end.
