unit childMoz;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, ComCtrls,
  ToolWin, ImgList, OleCtrls, SHDocVw,main,SysUtils, MOZILLACONTROLLib_TLB,IniFiles;

type
  Tfrm_MZ = class(TForm)
    TWeb_MZ: TMozillaBrowser;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TWeb_MZNewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure TWeb_MZProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure TWeb_MZStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure TWeb_MZTitleChange(Sender: TObject; const Text: WideString);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure TWeb_MZCommandStateChange(Sender: TObject; Command: Integer;
      Enable: WordBool);
    procedure SubChange(Enable:WordBool);
  private
    { Private 錾 }
    strURL: string;
    blBack	: WordBool;
    blFrwrd	: WordBool;
    blStop 	: WordBool;
    blReLoad: WordBool;
    tmpBool: WordBool;
    tmpPosition:Integer;
  public
    { Public 錾 }
  end;

implementation
uses
	untTab, tmpWeb;

procedure Tfrm_MZ.SubChange(Enable:WordBool);
begin
  //߂Eiނ̏󋵂L
	with MainForm do begin
  	if Enable=True then begin
  		Tfrm_MZ(ActiveMDIChild).blBack:=BackCtrl.Enabled;
  		Tfrm_MZ(ActiveMDIChild).blFrwrd:=FrwrdCtrl.Enabled;
    	Tfrm_MZ(ActiveMDIChild).blReLoad:=ReLoadCtrl.Enabled;
  		Tfrm_MZ(ActiveMDIChild).blStop:=StopCtrl.Enabled;
    end else begin
  		ProgressBar1.Position:=0;
		  txtAddress.Text:='';
		  StatusBar1.Panels.Items[0].Text:='';

		  //c[{^
				BackCtrl.Enabled:=False;
				FrwrdCtrl.Enabled:=False;
				ReLoadCtrl.Enabled:=False;
				StopCtrl.Enabled:=False;
		end;
  end;
end;
{$R *.DFM}

procedure Tfrm_MZ.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //lɖ߂
  tmpBool:=False;
  	//OtĕۑFalse
  		MainForm.mnuFile_SaveAs.Enabled:=False;
  	//ҏWj[False
  		MainForm.mnuEdit_slrAll.Enabled:=False;
    	MainForm.mnuEdit_Copy.Enabled:=False;
  	//TCYFalse
  		MainForm.mnuShow_Size.Enabled:=False;
  //^u
    untTab.WinColes(self.Tag);
  //^uXgɓo^
    MainForm.CloseTabs.Add(TWeb_mz.LocationURL);
		if MainForm.CloseTabs.Count>10 then MainForm.CloseTabs.Delete(0);
  //AhXo[
  	MainForm.txtAddress.Text:='';
  //
  	Action := caFree;
end;

procedure Tfrm_MZ.FormResize(Sender: TObject);
begin
  //TCY̒`
  TWeb_mz.Width:=Self.Width-10;
  TWeb_mz.Height:=Self.Height-30;

  //tH[JXɃEBhETCYL
  if self.WindowState<>wsMinimized then
			MainForm.WindowSize:=self.WindowState;
end;

procedure Tfrm_MZ.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  //TCY̒`
  TWeb_mz.Width:=Self.Width-10;
  TWeb_mz.Height:=Self.Height-30;
end;

procedure Tfrm_MZ.FormCreate(Sender: TObject);
begin
  TabCloseAll:=False;

  self.OnResize(Sender);
  self.Caption:='Gecko';
  WindowState:=MainForm.WindowSize;
  //߂Eiނ̏󋵂L
 	With Main.MainForm do begin
  	blBack:=BackCtrl.Enabled;
  	blFrwrd:=FrwrdCtrl.Enabled;
  	blStop:=StopCtrl.Enabled;
  end;
  tmpBool:=True;
end;

procedure Tfrm_MZ.FormActivate(Sender: TObject);
begin
  //ANeBȕ
  //URL̕ύX
  MainForm.txtAddress.Text:=TWeb_mz.LocationURL;
  //vOXo[̕ύX
  MainForm.ProgressBar1.Position:=tmpPosition;
  //TCY̍Ē`
  FormResize(sender);

  With Main.MainForm do begin 
  //߂Eiނ̏󋵂ύX
 	 	BackCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blBack;
  	FrwrdCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blFrwrd;
  	StopCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blStop;
    ReLoadCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blReLoad;

  //OtĕۑTrue
  	mnuFile_SaveAs.Enabled:=True;
  //ҏWj[True
  	mnuEdit_slrAll.Enabled:=True;
    mnuEdit_Copy.Enabled:=True;
  //TCYFalse
  	mnuShow_Size.Enabled:=False;

  //Ή^uI
    if TabCloseAll=False then
    		TabControl1.TabIndex:=fncTabTag(self.Tag);
  end;
end;

procedure Tfrm_MZ.TWeb_MZProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
//vOXo[̕\
var
	tmpInt:Byte;
begin
//ANeBu̔f
	if self.Active=True then
  begin
		if Progress<>0 then begin
			MainForm.Progressbar1.Position:= Progress*100
		              div ProgressMax;
		end;

 		//Sēǂݍ񂾂珉
  	tmpInt:=MainForm.Progressbar1.Position;
  	if tmpInt=100 then begin
    	MainForm.Progressbar1.Position:=0;
    	MainForm.StopCtrl.Enabled := False;
  	end else begin
    	MainForm.StopCtrl.Enabled := True;
  	end;
		//ǂݍ݋\
		tmpPosition:=MainForm.Progressbar1.Position;
	end;
end;

procedure Tfrm_MZ.TWeb_MZStatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  //}EXǂĂ邩`FbN
  MainForm.StatusBar1.Panels.Items[0].Text:=text;
  strURL:=text;
end;

procedure Tfrm_MZ.TWeb_MZTitleChange(Sender: TObject;
  const Text: WideString);
begin
  //^Cgς̏
  self.Caption:=text;
  MainForm.TabControl1.Tabs.Strings[untTab.fncTabTag(self.tag)]:=text;
  MainForm.txtAddress.Text:=TWeb_mz.LocationURL;
end;


procedure Tfrm_MZ.TWeb_MZCommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  With Main.MainForm do begin
  	case Command of
  	  CSC_NAVIGATEBACK: BackCtrl.Enabled := Enable;
  	  CSC_NAVIGATEFORWARD: FrwrdCtrl.Enabled := Enable;
   	end;
    ReLoadCtrl.Enabled:=True;
    SubChange(tmpBool);
  end;

end;

procedure Tfrm_MZ.TWeb_MZNewWindow2(Sender: TObject; var ppDisp: IDispatch;
  var Cancel: WordBool);
var
	form : TForm;
	wb : TWebBrowser;
begin
	//VKEBhE̍쐬
		ppDisp:=frm_tmpWeb.WebBrowser1;
		form := Tfrm_tmpWeb.Create(Application);
	  wb := Tfrm_tmpWeb(form).WebBrowser1;
	  wb.Tag:=-3;
	  ppDisp := wb.ControlInterface as Idispatch;
end;

end.
